# Parsim v1.0.3 beta
# Modified 11 December, 2002
# (c) Jonathan Jeffery 2002
#
# Reads output files from Parsimv program and 
# uses a charatcter-name-list file to
# replace character numbers with more 
# user-friendly character names
use File::Basename;
use utf8;
@SuffixList = ('\..*');

##################################################
#Startup

@TestManFile = ('f','m');
while(1){
	print "\nDo you want to use a batch-file or enter the settings manually? \(f\\m\)\n   ";
	$Man_or_file = <STDIN>;
	chomp($Man_or_file);
	$Man_or_file =~ tr/A-Z/a-z/;
	$GreppingTest = grep(/$Man_or_file/, @TestManFile);
	if($GreppingTest == 0){next}
	else{last}
	}
if($Man_or_file eq "m"){&Manual_Input}
else{&Batch_File}


sub Batch_File {
	print "\nWhat batch-file do you want to use?\n   ";

	while(1){
		$InputBatchFile = <stdin>;
		chomp ($InputBatchFile);
		if((-e $InputBatchFile) == 1){last};
		print "\nCan\'t find that file (wrong spelling or file path?).";
		print "\nPlease try again:\n   ";
		}

	@BatchFileDetails = fileparse($InputBatchFile, @SuffixList);
	$MyPath = $BatchFileDetails[1];
	$InFile = $BatchFileDetails[0] . $BatchFileDetails[2];

	$InputBatchFile =~ tr/A-Z/a-z/;
	open(BATCH,  '<', $InputBatchFile);


	#Put whole infile into a list
	@InputBatchList = <BATCH>;

	$Mac = chr(015);
	$PC = chr(012);
	for ($i = 0; $i <= $#InputBatchList; $i++) {
		$line = $InputBatchList[$i];
		$line =~ s/$Mac|$PC/\n/g;
		$line =~ tr/\n/\n/s;

		@TempList = split(/\n/, $line);
		for ($TT = 0; $TT <= $#TempList; $TT++){
			$TempLine = $TempList[$TT];
			unless(length($TempLine) == 0){
				push(@FinalBatchList, $TempLine)
				}
			}
		}

	foreach $BatchLine (@FinalBatchList){
		@Details_of_Run = split(/\t/, $BatchLine);
		$TheFile = $Details_of_Run[0];
		open(TOCLEAN,  '<', $TheFile);
		
		chop($TheFile);
		chop($TheFile);
		chop($TheFile);
		$TheFile = "$TheFile"  . "cln";
		open(CLEANED,  '>', $TheFile);
		open(DEFINE,  '<', $Details_of_Run[1]);
		print "\nopening $Details_of_Run[0] for cleaning by $Details_of_Run[1]";
		&MainProg;
		}
	}



sub Manual_Input {
	# Get input file name and open it
	print "\nWhat file do you want to use?\n";
	print "File must be in local directory, and be in Nexus output format:\n   ";

	$TheFile = <stdin>;
	chomp ($TheFile);
	$TheFile =~ tr/A-Z/a-z/;
	open(TOCLEAN,  '<', $TheFile) or die "The file $TheFile could not be found.\n";

	chop($TheFile);
	chop($TheFile);
	chop($TheFile);
	$TheFile = "$TheFile"  . "cln";

	open(CLEANED,  '>', $TheFile);

	print "\nWhat file do you want to use as a definition file?\n";
	print "File must be in local directory:\n   ";

	$TheFile = <stdin>;
	chomp ($TheFile);
	$TheFile =~ tr/A-Z/a-z/;
	open(DEFINE,  '<', $TheFile) or die "The file $TheFile could not be found.\n";
	&MainProg;
	
	}


sub MainProg {
#############################################
#Read char definitions, clean Mac-PC, and create to & from lists
	@InputFile = ();
	@OutList = ();
	@To = ();
	@From = ();
	@CleanedList = ();
	
	@InputFile = <DEFINE>;
	&MacPC_Clean;
	@Defined = @OutList;
	
	for ($i = 0; $i <= $#Defined; $i++) {
			$TheLine = $Defined[$i];
			chomp $TheLine; 
			$TheLine =~ s/ $//g;
			@Temp = split(/\t/, $TheLine);
			push(@From, $Temp[0]);
			push(@To, $Temp[1]);
			}

	@InputFile = ();
	@OutList = ();

	#############################################
	#Convert char numbers to names
	@InputFile = <TOCLEAN>;
	&MacPC_Clean;
	@FinalList = @OutList;

	for ($i = 0; $i <= $#FinalList; $i++) {
			$TheLine = $FinalList[$i];

		unless(($TheLine =~ /^Consensus/) or 
			($TheLine =~ /^Node/) or
			($TheLine =~ /Run took/) or
			($TheLine =~ /characters with/) or
			($TheLine =~ /apomorphies/) or
			($TheLine =~ /iterations/)){
			for ($e = $#From; $e >= 0; $e--){ 
				$FromScore = $From[$e];
				$ToScore = $To[$e];

				$TheLine =~ s/^Char $FromScore /$ToScore\t/g;
				$TheLine =~ s/\($FromScore,/\($ToScore,/g;
				$TheLine =~ s/ $FromScore\)/ $ToScore\)/g;
				$TheLine =~ s/ $FromScore | $FromScore$/ $ToScore /g;
				$TheLine =~ s/ $FromScore,/ $ToScore,/g;
				}
			}
	if($TheLine =~ /iterations/){$TheLine = "$TheLine" . "\n"}
	elsif($TheLine =~ /For each node/){$TheLine = "\n" . "$TheLine"}
	elsif($TheLine =~ /=======/){$TheLine = "\n" . "$TheLine"}
	elsif($TheLine =~ /%/){$TheLine = "$TheLine" . "\n"}
	elsif($TheLine =~ /shortest runs/){$TheLine = "$TheLine" . "\n"}
	elsif($TheLine =~ /All characters used/){$TheLine = "$TheLine" . "\n"}

	push(@CleanedList, $TheLine);
			}

	for ($i = 0; $i <= $#CleanedList; $i++) {
				print CLEANED "$CleanedList[$i]\n";};


	print "\nOK, done\n";
	close(CLEANED);
	close(DEFINE);
	close(TOCLEAN);
	}



##############################################################
#sub to convert Mac & PC linebreaks
sub MacPC_Clean {
	$Mac = chr(015);
	$PC = chr(012);

	for ($i = 0; $i <= $#InputFile; $i++) {
		$line = $InputFile[$i];
		$line =~ s/$Mac|$PC/\n/g;
		$line =~ tr/\n/\n/s;
		@TempList = split(/\n/, $line);

		for ($TT = 0; $TT <= $#TempList; $TT++){
			$TempLine = $TempList[$TT];
			push(@OutList, $TempLine)
			}
		}
	}
##############################################################